package emfcomparetime;
import java.io.File;
import org.eclipse.emf.common.util.URI;

import org.eclipse.emf.compare.*;
import org.eclipse.emf.compare.match.DefaultComparisonFactory;
import org.eclipse.emf.compare.match.DefaultEqualityHelperFactory;
import org.eclipse.emf.compare.match.DefaultMatchEngine;
import org.eclipse.emf.compare.match.IComparisonFactory;
import org.eclipse.emf.compare.match.IMatchEngine;
import org.eclipse.emf.compare.match.eobject.IEObjectMatcher;
import org.eclipse.emf.compare.match.impl.MatchEngineFactoryImpl;
import org.eclipse.emf.compare.match.impl.MatchEngineFactoryRegistryImpl;
import org.eclipse.emf.compare.scope.IComparisonScope;
import org.eclipse.emf.compare.utils.UseIdentifiers;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.emf.ecore.xmi.impl.XMIResourceFactoryImpl;
import org.eclipse.core.runtime.Plugin;
import org.eclipse.emf.ecore.EPackage.*;
import org.eclipse.emf.ecore.resource.*;
import org.eclipse.uml2.uml.resource.*;
import org.eclipse.uml2.uml.*;
import org.eclipse.uml2.uml.resource.UMLResource;
import org.eclipse.uml2.uml.resource.XMI2UMLResource;
import org.eclipse.uml2.uml.resources.*;
import org.eclipse.uml2.uml.resources.util.*;
import org.eclipse.papyrus.marte.properties.*;

public class EmfcompareExecTime {
	public Comparison compare(File model1, File model2) {
		// Load the two input models
		ResourceSet resourceSet1 = new ResourceSetImpl();
		ResourceSet resourceSet2 = new ResourceSetImpl();
		String xmi1 = "modelECommerce-Jan5.uml";
		String xmi2 = "modelECommerce-Jan5VR1.uml";
		load(xmi1, org.eclipse.uml2.uml.resources.util.UMLResourcesUtil.init(resourceSet1));
		load(xmi2, org.eclipse.uml2.uml.resources.util.UMLResourcesUtil.init(resourceSet2));
		//org.eclipse.uml2.uml.resources.util.UMLResourcesUtil.init(resourceSet1);
		//org.eclipse.uml2.uml.resources.util.UMLResourcesUtil.init(resourceSet2);
		// Configure EMF Compare
		IEObjectMatcher matcher = DefaultMatchEngine.createDefaultEObjectMatcher(UseIdentifiers.WHEN_AVAILABLE);
		IComparisonFactory comparisonFactory = new DefaultComparisonFactory(new DefaultEqualityHelperFactory());
		IMatchEngine.Factory matchEngineFactory = new MatchEngineFactoryImpl(matcher, comparisonFactory);
	        matchEngineFactory.setRanking(20);
	        IMatchEngine.Factory.Registry matchEngineRegistry = new MatchEngineFactoryRegistryImpl();
	        matchEngineRegistry.add(matchEngineFactory);
		EMFCompare comparator = EMFCompare.builder().setMatchEngineFactoryRegistry(matchEngineRegistry).build();

		// Compare the two models
		IComparisonScope scope = EMFCompare.createDefaultScope(resourceSet1, resourceSet2);
		return comparator.compare(scope);
	}

	private void load(String absolutePath, ResourceSet resourceSet) {
	  URI uri = URI.createFileURI(absolutePath);
	  resourceSet.getPackageRegistry().put("http://www.eclipse.org/papyrus/MARTE/1", org.eclipse.papyrus.MARTE.MARTEPackage.eINSTANCE);
	  //resourceSet.getPackageRegistry().put()
	  Resource.Factory.Registry.INSTANCE.getExtensionToFactoryMap().put("modelECommerce-Jan5.uml", UMLResource.Factory.INSTANCE);
	  Resource.Factory.Registry.INSTANCE.getExtensionToFactoryMap().put("modelECommerce-Jan5VR1.uml", UMLResource.Factory.INSTANCE);
	  // Resource will be loaded within the resource set
	  resourceSet.getResource(uri, true);
	}

	public static void main(String[] args)
	{
		EmfcompareExecTime ee = new EmfcompareExecTime();
		ee.compare(null,null);
	}
}
